/*#######################################################################################
AVR Small Webserver 

Copyright (C) 2004 Ulrich Radig
          (C) 2005 Mark Haemmerling <avr.webserver@markh.de>

#######################################################################################*/

/*
LittleFeather.org

...das war der projektname, den ich vorgesehen hatte. das ganze sollte ein leistungsfaehigerer webserver
werden, mit CGI und SMTP-client. das laeuft soweit ja auch. aber mangels ressourcen ist z.b. ein tcp-resend
nicht moeglich. das wird schnell zum problem wenn mal ein paket verloren geht. insofern wird das wohl nie ein
professionelles level erreichen. ;(

Die folgenden Kommentare waren eigentlich nur fuer mich bestimmt. Zum Verstaendnis lass ich sie mal drin.
Teilweise sind die ToDos auch schon fertig (z.B. die Mailtrigger-bits)

Features ToDo:
- connection refused bei ungltigem port, bzw. wenn keine sockets mehr frei sind (spezialcode?)
- IP address des partners im stack halten! momentan wird die nicht verglichen! sehr leicht angreifbar!
- eeprom-write raus -> daten in ram!!
- MAC aus karte auslesen
- ber gateway rausgehen
- config-files fr IP, HTTP usw. auf die karte
- mehr als 16kB je file

todo:
statt OPEN2 lieber das neue ->CommStage nehmen. ist sauberer
tag-ersetzungsroutine(n) auslagern!
form:
void subst(*buffer, *bufferlen, *open_tag_len);
-> verndert werden bufferlen, und natrlich auch open_tag_len.
!! buffer mu nach hinten raus "offen" sein, weil buffer ja grer werden kann!
evtl. noch eine hchstgrenze mit angeben. damit die routine abbricht wenn er doch zu lang wird.
kein problem, wird dann einfach open_tag_len entsprechend eingestellt, so da der rest
beim nchsten durchlauf mitbehandelt wird.

fr die mglichkeit, die externe unit (i/o-teil) doch eigenstndig zu machen:
man knnte an bestimmten stellen des gemeinsamen speichers event-trigger-bytes einsetzen
d.h. z.b. um eine mail abschicken zu lassen:
byte1 = SEND_MAIL; byte2 = 4; byte0 = EVENT_TRIGGER;
byte2 wrde z.b. nummer der email enthalten... diese email liegt auf der karte unter "MAIL_004.TXT" oder so.
das ganze passiert im r/w bereich. wenn der server kenntnis genommen hat, setzt er byte0 (den trigger)
wieder auf idle-zustand
klingt hlich und kompliziert, aber ist evtl. gar keine so blde idee... wenn man nicht
gerade dynamische texte verschicken will. obwohl so sachen wie empfnger (also per index) etc. knnte man auch
ber eine variable einsetzen lassen. daten sollten meist von der sdcard kommen (weil das der user
leicht ndern kann). nichts sollte hardcoded im server liegen. d.h. der server soll als geschlossenes
system (auch im physischen sinne) arbeiten knnen. i/o-unit wird dann einfach angesteckt.
was dynamische werte angeht: die knnte man natrlich in tag-form genau wie in den lfo-files
in die mails schreiben. damit knnte man status-mails (also wo aktuelle werte drin stehen) wirklich
einfach versenden.
*/

#include "main.h"
#include "httpd.h"

#include <webpage.h>

//MH//
#define BLOCK_SIZE BlockSize // aus fat.h

int substitute(unsigned char val_type, unsigned char var_addr, unsigned char size, unsigned char *dest, unsigned char *format);

/*
//MH//
Todo:
- content type im header entsprechend anpassen:
  htm -> text/html
  jpg -> image/jpeg (jpg?)
  gif -> image/gif
  png -> image/png
  *   -> text/plain
*/

//MH:
// bestimmung der stackposition allgemein in der tcp.c machen, und adresse an ftpd/httpd...
// bergeben. so da nicht jeder daemon das selbst machen mu. mu er ja eh, weil tcp=verbindungsorientiert

//############################################################################
//HTTP daemon (wird der LittleFeather.org webserver!)
//############################################################################
void httpd (char* buffer,int *bufferlen) {	
	unsigned int tcpdata;
	//Errechnet startpunkt der Daten im Tcp buffer
	//IP Headerlnge + TCP Headerlnge + Ethernetframe
	tcpdata = ((buffer[IP_VERS_LEN] & 0x0F) << 2) + ((buffer[TCP_HDRFLAGS] & 0xF0) >>2) + 14;

	//Verwaltung Stackpointer

	unsigned char a;//Stack Speichplatz Default (0..10)
	if (TCP_Stack(buffer,bufferlen,&a) == 1) return; //keine Daten fr Anwendung

	tcp_socket = &tcpsockets[a]; //Pointer auf tcpsockets[a] holen
	
	//berprft HTTP Header 
	if ((buffer[TCP_HDRFLAGS+1]&PSH_FLAG) > 0 && tcp_socket->Status == TCP_SOCKET_OPEN1) {
		unsigned char extension = 0;
			
		//Pointerold auf 404-Seite
		pointerold = HTTP_PAGENOTFOUND;
		
		//File_Name entspricht 8.3 & Endmakierung
		unsigned char File_Name[13];

		//berprft Header nach "GET /File_Name HTTP....."
		if (memcmp(&buffer[tcpdata], "GET /",5) == 0) {
			char *tmppointer = &buffer[tcpdata + 5];
			unsigned char counter;
			
			tcp_socket->Open_Tag_Len = 0;
			//Der Header wird durchsucht beginnend bei GET /
			counter = 0;
			while (1) {
				if (counter >= (sizeof(File_Name) - 1)) break;
				if (*tmppointer == ' ') break;
				if (*tmppointer == '?') {
					// CGI-Daten beginnen hier:
					unsigned char *pos_addr, *pos_value;
					unsigned char var_type, tmp;
					tmppointer++;
					while (1) {
						unsigned char var_addr;
						// !> if zu weit: break;
						var_type = *tmppointer; // typen-code (b,w...)
						tmppointer++; // beginn der adresse
						pos_addr = tmppointer; // merke beginn der addr
						while (*tmppointer != '=') tmppointer++; // !> abbruch wenn zu lang!
						*tmppointer = '\0'; // fuer atoi()
						tmppointer++; // auf beginn des wertes
						pos_value = tmppointer; // merke beginn des wertes
						while ((*tmppointer != '&') && (*tmppointer != ' ')) tmppointer++; // !> abbruch wenn zu lang!
						tmp = *tmppointer; // merke trennzeichen
						*tmppointer = '\0';
						if (var_type == 'b') { // !> var_addr prfen!!!! darf nur in zugelassenen bereich schreiben!!! < VARS_RW_BOUNDARY oder so
							unsigned char pos_bit = 0, shift = 0xff; // shift ist >= 8, um standardmig bitzuweisung zu verhindern
							while (pos_addr+pos_bit+2 < pos_value) { // solange ein '.' kommen kann
								if (pos_addr[pos_bit] == '.') {
									shift = pos_addr[pos_bit+1] - '0';
									pos_addr[pos_bit] = '\0'; // fuer atoi()
									break;
								}
								pos_bit++;
							}
							var_addr = atoi(pos_addr);
							if (var_addr < (VARS_RW_BYTES)) {
								if (shift < 8) {
									if (atoi(pos_value) != 0) {
										vars.type_char[var_addr] |= (1<<shift);
									} else {
										vars.type_char[atoi(pos_addr)] &= ~(1<<shift);
									}
								} else {
									vars.type_char[atoi(pos_addr)] = atoi(pos_value);
								}
							}
						} else if (var_type == 'w') {
							var_addr = atoi(pos_addr);
							if (var_addr < (VARS_RW_BYTES / 2)) {
								vars.type_int[atoi(pos_addr)] = atoi(pos_value);
							}
						}
						tmppointer++;
						if (tmp == ' ') break; // wenn trennzeichen ein ' ' war, abbruch
					}
					break;
				}
				File_Name[counter] = *tmppointer;
				counter++;
				tmppointer++;
			}
				
			//Endmakierung setzen
			File_Name[counter] = '\0';
			
			//Enthlt der Header keinen File Namen ist dieser Index.htm
			if (File_Name[0] == '\0') sprintf(File_Name, "index.lfo");
				// !> hier erst durchprobieren: index.htm, index.lfo

			printf(File_Name);
			printf("\n");

			counter = 0;
			while (File_Name[counter] != 0) {
				if (File_Name[counter] == '.') { extension = counter; break; }
				counter++;
			}

			#if USE_MMC
			//Durchsucht Root Verzeichnis nach File Namen
			unsigned char Dir_Attrib;

			//Lade Cluster fr das File welches in File_Name steht 
			tcp_socket->Cluster = 0; //suche im Root Directory
			if (Search_File(File_Name, &tcp_socket->Cluster, &tcp_socket->File_Size, &Dir_Attrib, &buffer[tcpdata]) == 1) {
				tcp_socket->File_Block_Counter = 0;
			} else {
				//wurde das File nicht gefunden, wird Seite aus Flashspeicher angezeigt
				tcp_socket->Cluster = 0;
			}
			#endif //USE_MMC
		}
		
		// ulrich weg (nicht persoenlich gemeint *g*), aber evtl nen LittleFeather-logo fr die 404 seite und evtl. noch eine integrierte info-seite, wo compileroptionen drin sind (und defines...)
/*					
		if ( memcmp(File_Name,"ulrich.jpg",10) == 0)
			{
			//Pointerold auf ulrich.jpg
			pointerold = Page2;
			}
			
		if ( memcmp(File_Name,"ulrich1.jpg",11) == 0)
			{
			//Pointerold auf ulrich1.jpg ist gleich ulrich.jpg
			pointerold = Page2;
			}
*/			
		//Speichert Sequenzcounter und Aknowledgecounter
		tcp_store(buffer);	
	
		//Setzen des Ack Flags und PSH Flags	
		buffer[TCP_HDRFLAGS+1] = ACK_FLAG | PSH_FLAG;

		//erzeuge HTTP antwortheader
		if (tcp_socket->Cluster == 0) {
			tcp_add_data (HTTP_404,buffer,bufferlen);
		} else if (strcasecmp(File_Name+extension, ".lfo") == 0) {
			tcp_socket->Subst_Tags = 1;
			tcp_add_data (HTTP_200_HTML,buffer,bufferlen);
		} else if (strcasecmp(File_Name+extension, ".htm") == 0) {
			tcp_socket->Subst_Tags = 0;
			tcp_add_data (HTTP_200_HTML,buffer,bufferlen);
		} else if (strcasecmp(File_Name+extension, ".jpg") == 0) {
			tcp_socket->Subst_Tags = 0;
			tcp_add_data (HTTP_200_JPEG,buffer,bufferlen);
		} else {
			tcp_socket->Subst_Tags = 0;
			tcp_add_data (HTTP_200_PLAIN,buffer,bufferlen);
		}
		//Erzeugt ein TCP Packet 
		tcp_make(buffer);
		//Sendet das erzeugte TCP Packet 
		Write_Ethernet_Frame (buffer,*bufferlen);
		//(Ethernet Farne war aber voll) Weiters Frame mu gesendet werden!
		tcp_socket->Status = TCP_SOCKET_OPEN2;
		tcp_socket->Pointer = pointerold;
		return;
		}
	
	//Senden der Webseite bzw. Daten war noch nicht Fertig (Ethernet Farne war aber voll)
	if (tcp_socket->Status == TCP_SOCKET_OPEN2) {
		unsigned char remaining_data = 0;
		//Setzen des Ack Flags und PSH Flags	
		buffer[TCP_HDRFLAGS+1] = ACK_FLAG | PSH_FLAG;
		//Speichert Sequenzcounter und Aknowledgecounter
		tcp_store(buffer);		
		//erzeugt Seiten Packet
		
		#if USE_MMC
		if(tcp_socket->Cluster != 0) {
//			read_file_and_expand(tcp_socket->Cluster, buffer+tcpdata, tcp_socket->File_Block_Counter);
			unsigned int use_size;
			unsigned int a;
			unsigned char *work_buffer = buffer+tcpdata; // zur Vereinfachung

			if (tcp_socket->File_Size > (unsigned long) BLOCK_SIZE) {
				use_size = BLOCK_SIZE;
				remaining_data = 1;
				(unsigned long) tcp_socket->File_Size = (unsigned long) tcp_socket->File_Size - BLOCK_SIZE;
			} else {
				use_size = tcp_socket->File_Size;
				remaining_data = 0;
			}

//			printf("blk=%u, us=%u\n", tcp_socket->File_Block_Counter, use_size);
			
			// hier evtl. alten block nochmal laden und verschieben!
			if ((tcp_socket->File_Block_Counter > 0) && (tcp_socket->Open_Tag_Len > 0)) {
				// letzter Block enthielt am Ende ein offenes Tag.
				// dieses Tag wird nun vor diesen Block kopiert, so da es komplett verarbeitet werden kann
				Read_File(tcp_socket->Cluster, work_buffer, tcp_socket->File_Block_Counter - 1); // vorheringen Block nochmals laden
				for (a = 0; a < tcp_socket->Open_Tag_Len; a++) {
					work_buffer[a] = work_buffer[BLOCK_SIZE - tcp_socket->Open_Tag_Len + a];
				}
				// neuen Block dahinter laden
				Read_File(tcp_socket->Cluster, work_buffer + tcp_socket->Open_Tag_Len, tcp_socket->File_Block_Counter);
				use_size += tcp_socket->Open_Tag_Len; // pufferlnge entsprechend erhhen
			} else {
				// kein Tag-Umbruch. also ganz normal diesen Block einzeln laden
				Read_File(tcp_socket->Cluster, work_buffer, tcp_socket->File_Block_Counter);
			}
			tcp_socket->File_Block_Counter++;
			tcp_socket->Open_Tag_Len = 0;

			// Tags ersetzen (nur wenn geeigneter content type)
			if (tcp_socket->Subst_Tags) {;
				a = 0;
				while (a < use_size) {
					if (work_buffer[a] == '{') { // Anfang eines Tags ('{') erkannt
						unsigned char val_type, i, j, tag_len, subst_len = 0;
						unsigned char var_addr;
						unsigned char boolean = 0xff; // 0=false, 1=true, sonst=keine bool-auswertung
						unsigned char format[6];
						
						// !> beim weiteren parsen immer checken, da tag_len nicht berschritten wird,
						// bzw. } nicht erreicht wird -> sonst abbruch und tag durch nichts ersetzen
						// also subst_len auf default (=0) lassen, tag_len ist ja schon bekannt
						// also wird tag durch nichts ersetzt, sprich gelscht bzw. ignoriert
						
						i = 1; // finde heraus, ob tag offen ist. beginne mit suche direkt hinter dem '{'
						while ((a+i < use_size) && (work_buffer[a+i] != '}')) i++;
						if (!(a+i < use_size)) { // also sind wir am ende angekommen -> offenes tag
							tcp_socket->Open_Tag_Len = (use_size - a);
							break;
						}
						tag_len = i+1;
			
						// typ der einzusetzenden variablen erkennen (b, w):
						val_type = work_buffer[a+1];
						
						// adresse der einzusetzenden variablen bestimmen:
						i = 0;
						// !> schauen, da kein } kommt (falsches format)... was passiert, wenn zu weit geparst wurde??
						while ((i < 4) && (work_buffer[a+2+i] != ':') && (work_buffer[a+2+i] != '.')) i++;

						if (work_buffer[a+2+i] == '.') { // trennzeichen war '.', also bitnr. parsen
// weiter unten abbrechen							if (val_type != 'b') break;
							boolean = work_buffer[a+3+i] - '0'; // noch bedeutet diese variable nur nummer des bits!!
						}						
		
						// adresse in integer verwandeln:
						work_buffer[a+2+i] = '\0';
						var_addr = atoi(work_buffer+a+2);
		
						if (boolean < 8) { // boolsche auswertung
							// ersten doppelpunkt suchen (sollte eigentlich gleich dahinter kommen)
							i += 4;
							while (work_buffer[a+i] != ':') i++; // !> abbruch wenn zu lang
							i++;
							// true-teil beginnt hier
							j = 0;
							while (work_buffer[a+i+j] != ':') j++; // lnge des true-teils bestimmen

							if (val_type == 'b') {
								if (vars.type_char[var_addr] & (1<<boolean)) {
									memmove(work_buffer+a, work_buffer+a+i, j);
									subst_len = j;
								} else {
									i += j+1;
									j = 0;
									while (work_buffer[a+i+j] != '}') j++; // lnge des false-teils bestimmen
									memmove(work_buffer+a, work_buffer+a+i, j);
									subst_len = j;
								}
							}
						} else {
							// formatstring bestimmen:
							format[0] = '%';
							j = 0;
							while (work_buffer[a+3+i+j] != '}') {
								if (j >= sizeof(format)-1) break; // format luft ber -> undefiniert!!
								format[j+1] = work_buffer[a+3+i+j]; // in lokalen formatstring kopieren
								j++;
							}
							format[j+1] = '\0';

							// herausfinden wie lang das ergebnis wird
							subst_len = substitute(val_type, var_addr, 0, NULL, format); // j ist nun Lnge des neuen Stckes
						}
						
						// Puffer entsprechend verlngern oder krzen (Rest wird verschoben)
						memmove(work_buffer+a+subst_len, work_buffer+a+tag_len, use_size-a-tag_len);
						use_size += subst_len - tag_len;

						if (!(boolean < 8)) {
							// nun ohne \0 direkt in den puffer hineinkopieren
							substitute(val_type, var_addr, subst_len, work_buffer+a, format);
						}

						a += subst_len; // ber ersetzten teil springen (tags knnen nicht andere tags enthalten)
						// fr verschachtelte tags: anzahl enthaltener tags mte gezhlt werden ("%{" -> tags++, "}" -> tags--)
						// erst bei tags == 0 mte auf "}" reagiert werden... offene tags auch sauber handeln! is was fr 2.0 :)
					} else {
						a++;
					}
				}
	
				// Puffer ggf. bis zum Anfang des offenen Tags krzen:
				use_size -= tcp_socket->Open_Tag_Len;
				//printf("OTL=%u\n", tcp_socket->Open_Tag_Len);
			} // ende if (contenttype==html)

			TCP_New_Packtlen(buffer, bufferlen, tcpdata + use_size);
			goto endmakepacket;
		}
		#endif //USE_MMC
	
		//MH// dies hier wird bersprungen wenn daten von sd kommen (durch goto hier oben!)
		pointerold = tcp_socket->Pointer;
		remaining_data = tcp_add_data (pointerold,buffer,bufferlen);
		tcp_socket->Pointer = pointerold;

		#if USE_MMC
		endmakepacket:
		#endif //USE_MMC

		//Erzeugt ein TCP Packet 
		tcp_make(buffer);			
		//Sendet das erzeugte TCP Packet 
		Write_Ethernet_Frame (buffer,*bufferlen);	
		if (remaining_data == 0) {
			#if USE_MMC
			tcp_socket->Cluster = 0;
			#endif //USE_MMC
			tcp_socket->Status = TCP_SOCKET_CLOSE;
		}
		return;		
	}
	return;
}

int substitute(unsigned char val_type, unsigned char var_addr, unsigned char size, unsigned char *dest, unsigned char *format) {
	unsigned char behind = dest[size];
	unsigned char length;

	size++;
	if (val_type == 'b') {
		length = snprintf(dest, size, format, vars.type_char[var_addr]);
	} else if (val_type == 'w') {
		length = snprintf(dest, size, format, vars.type_int[var_addr]);
	} else length = 0;;
	if (dest != NULL) { dest[size-1] = behind; length--; }
	return length;
}
