/*#######################################################################################
AVR Small Webserver 

Copyright (C) 2004 Ulrich Radig
          (C) 2005 Mark Haemmerling <avr.webserver@markh.de>

#######################################################################################*/
#include "main.h"
#include "webpage.h"

PROGMEM char HTTP_200_HTML[] = {
"HTTP/1.0 200 OK\n"
"Server: LittleFeather.org/0.1\n" 
"Connection: close\n" 
"Content-Type: text/html\n"
"\n"
"%END"
};

PROGMEM char HTTP_200_JPEG[] = {
"HTTP/1.0 200 OK\n"
"Server: LittleFeather.org/0.1\n" 
"Connection: close\n" 
"Content-Type: image/jpeg\n"
"\n"
"%END"
};

PROGMEM char HTTP_200_PLAIN[] = {
"HTTP/1.0 200 OK\n"
"Server: LittleFeather.org/0.1\n" 
"Connection: close\n" 
"Content-Type: text/plain\n"
"\n"
"%END"
};

PROGMEM char HTTP_404[] = {
"HTTP/1.0 404 Page not found\n"
"Server: LittleFeather.org/0.1\n" 
"Connection: close\n" 
"Content-Type: text/html\n"
"\n"
"%END"
};

PROGMEM char HTTP_PAGENOTFOUND[] = {
"<!DOCTYPE HTML PUBLIC \"-//IETF//DTD HTML 2.0//EN\">"
"<HTML><HEAD>"
"<TITLE>404 Not Found</TITLE>"
"</HEAD><BODY>"
"<H1>Not Found</H1>"
"The requested URL was not found on this server.<P>"
"<HR>"
"<ADDRESS>LittleFeather.org/0.1 Server</ADDRESS>"
"</BODY></HTML>"
"%END" //%END = Ende des Files
};
